; Dragos MD3 Library for Blitz Basic, Revision 2.
; hopefully works better then version 1.
 Const BOTH_DEATH1 = 0 		; The First twirling death animation
 Const BOTH_DEAD1 =1 				; The End of the First twirling death animation
 Const BOTH_DEATH2 	=2		; The second twirling death animation
 Const BOTH_DEAD2 	=3			; The End of the second twirling death animation
 Const BOTH_DEATH3 	=4		; The back Flip death animation
 Const BOTH_DEAD3 	=5			; The End of the back Flip death animation

	; The Next block is the animations that the Upper body performs

 Const TORSO_GESTURE =6			; The torso's gesturing animation
	
 Const TORSO_ATTACK =7		; The torso's attack1 animation
 Const TORSO_ATTACK2 =8			; The torso's attack2 animation

 Const TORSO_DROP =9				; The torso's weapon drop animation
 Const TORSO_RAISE 	=10		; The torso's weapon pickup animation

 Const TORSO_STAND =11			; The torso's idle stand animation
 Const TORSO_STAND2 =12 			; The torso's idle stand2 animation

	; The final block is the animations that the legs perform

 Const LEGS_WALKCR 	=13		; The legs's crouching walk animation
 Const LEGS_WALK 	=14			; The legs's walk animation
 Const LEGS_RUN 	=15			; The legs's run animation
 Const LEGS_BACK 	=16			; The legs's running backwards animation
 Const LEGS_SWIM 	=17			; The legs's swimming animation
	
 Const LEGS_JUMP 	=18			; The legs's jumping animation
 Const LEGS_LAND 	=19			; The legs's landing animation

 Const LEGS_JUMPB 	=20			; The legs's jumping back animation
 Const LEGS_LANDB 	=21			; The legs's landing back animation

 Const LEGS_IDLE 	=22			; The legs's idle stand animation
 Const LEGS_IDLECR 	=23		; The legs's idle crouching animation

 Const LEGS_TURN 	=24			; The legs's turn animation


Type md3model
Field Head
Field body,bodyX#,bodyY#,bodyZ#
Field legs
Field entity
Field animation[25],framestart,frameend,frame#
End Type

Type MD3
	Field  MD3_kLower=0			;; This stores the ID For the legs model
 Field MD3_kUpper=1			;; This stores the ID For the torso model
 Field MD3_kHead=2			;; This stores the ID For the head model
 Field MD3_kWeapon=3			;; This stores the ID For the weapon model

 Field MAX_ANIMATIONS			; The define For the maximum amount of animations
;	Type handles For the model parts
 Field header, meshinfo[16], meshname$[16],tags
 Field mesh,filename$
 Field frame#=0,startframe=0,endframe=0
End Type

Global frame=0
;This holds the header information that is read in at the beginning of the file
Type tMd3Header 
 
     Field	fileID$;					  This stores the file ID - Must be "IDP3"
	 Field		version;					  This stores the file version - Must be 15
	 Field	strFile$;				  This stores the name of the file
	 Field		numFrames;					  This stores the number of animation frames
	 Field		numTags;					  This stores the tag count
	 Field		numMeshes;					  This stores the number of sub-objects in the mesh
	 Field		numMaxSkins;				  This stores the number of skins for the mesh
	 Field		headerSize;					  This stores the mesh header size
	 Field		tagStart;					  This stores the offset  fieldo the file for tags
	 Field		tagEnd;						  This stores the end offset  fieldo the file for tags
	 Field FSize;					  This stores the file size
End Type

; This Typeure is used To Read in the mesh Data For the .md3 models
Type tMd3MeshInfo
 
	Field	meshID$;					; This stores the mesh ID (We don't care)
	Field	strName$;				; This stores the mesh name (We do care)
	Field		numMeshFrames;				; This stores the mesh aniamtion frame count
	Field		numSkins;					; This stores the mesh skin count
	Field     numVertices;				; This stores the mesh vertex count
	Field		numTriangles;				; This stores the mesh face count
;	Field		triStart;					; This stores the starting offset for the triangles
	Field		headerSize;					; This stores the header size for the mesh
	;Field     uvStart;					; This stores the starting offset for the UV coordinates
	;Field		vertexStart;				; This stores the starting offset for the vertex indices
	Field		meshSize;					; This stores the total mesh size
	;handles....
	;Field 		Triangle , Face, Textcord, Skin
	Field		animbank					; stores all frame information. 
	Field 		vertoff						; stores vertex offset for interpolation.
End Type


; This is our tag Type For the .MD3 file format.  These are used link other
; models To And the rotate And transate the child models of that model.
Type tMd3Tag
 
	Field		strName$;			; This stores the name of the tag (I.E. "tag_torso")
	Field 	Frame
	Field	vPosition#[3];				; This stores the translation that should be performed
	Field		Roll#,Pitch#,Yaw#;			; This stores the rotation from the rotation matrix
End Type

; This stores the bone information (useless as far as I can see...)
;Type tMd3Bone
 
;	Field	mins#[3];					; This is the min (x, y, z) value for the bone
;	Field	maxs#[3];					; This is the max (x, y, z) value for the bone
;	Field	position#[3];				; This supposedly stores the bone position???
;	Field	scale#;						; This stores the scale of the bone;
;	Field	creator$;				; The modeler used to create the model (I.E. "3DS Max")
;End Type


; This stores the normals And vertex indices 
Type tMd3Triangle
 
   Field vertex[3];				; The vertex for this face (scale down by 64.0f)
   Field normal[2];				; This stores some crazy normal values (not sure...)
End Type

;Global frame=0
; This stores the indices fieldo the vertex And texture coordinate arrays
Type tMd3Face
 
   Field vertexIndices[3];				
End Type


; This stores UV coordinates
Type tMd3TexCoord
   Field textureCoord#[2];
End Type


; This stores a skin name (We don't use this, just the name of the model To get the texture)
Type tMd3Skin 
	Field strName$;
End Type


Type tmd3Animation
	Field strName$					; This stores the name of the animation (I.E. "TORSO_STAND")
	Field startFrame				; This stores the first frame number for this animation
	Field endFrame					; This stores the last frame number for this animation
	Field loopingFrames				; This stores the looping frames for this animation (not used)
	Field framesPerSecond			; This stores the frames per second that this animation runs
	Field part						; body part. 0=both, 1=upper, 2=lower.
End Type
; Function: OpenMD3
; Parameters Directory, the directory of the md3 model.
; returns: a handle that is used for all other model commands.
; Description:
;		This is the main loading command for an md3 model, loads the skins, meshes, and anination files,
;		And sets up the linking of the models.

Dim face(1,1),uv#(1,1),skin$(16,2),tagname$(8)
Function MD3_LOADING_FUNCTIONS()
End Function
Function MD3_OPEN.md3model(Directory$,skin$="Default")
; create the meshes used in the model...
ChangeDir Directory$
model.md3model=New md3model
root=CreatePivot()
model\entity=root

mesh_lower=CreateMesh(root)
mesh_upper=CreateMesh(mesh_lower)
mesh_head=CreateMesh(mesh_upper)
; load the files for the lower mesh. the lower mesh is loaded first since of the hirachy of the q3model format.
loadskin("lower",Skin$) ; loads the lower skin
; load the mesh of the md3 model.
model\legs=loadmd3("lower",mesh_lower)
md3.md3=Object.md3(model\legs)
; load the Link tag info in
For lp=4 To BankSize(md3\tags)-1 Step 4
hand=PeekInt(md3\tags,lp)
tag.tmd3tag=Object.tmd3tag(hand)
Print tag\strname+ " "+tag\vposition[1]+","+tag\vposition[2]+","+tag\vposition[3]
Print lp+" "+tag\frame
If tag\strname=Lower("TAG_TORSO")
PositionEntity mesh_upper,tag\vposition[1],tag\vposition[2],tag\vposition[3]
;RotateEntity mesh_upper,tag\pitch#,tag\yaw#,tag\roll#
;RotateEntity mesh_head,tag\pitch#,tag\yaw#,tag\roll#
Exit
EndIf
Next


; load the files for the upper mesh.
loadskin("upper",Skin$) ; loads the upper skin
; load the mesh of the md3 model.
model\body=loadmd3("upper",mesh_upper)
md3.md3=Object.md3(model\body)
; load the Link tag info in
For lp=4 To BankSize(md3\tags)-1 Step 4
hand=PeekInt(md3\tags,lp)
;Print lp + " value:"+ hand
tag.tmd3tag=Object.tmd3tag(hand)
Print tag\strname+ " "+tag\vposition[1]+","+tag\vposition[2]+","+tag\vposition[3]
Print lp+" "+tag\frame
;ai;Key
If tag\strname=Lower("TAG_HEAD") And tag\frame=0
PositionEntity mesh_head,EntityX(mesh_upper)+tag\vposition[1],EntityY(mesh_upper)+tag\vposition[2],EntityZ(mesh_upper)+tag\vposition[3]
;Exit
EndIf
Next
; load the files for the head mesh. 
loadskin("head",Skin$) ; loads the head skin
; load the mesh of the md3 model.
model\head=loadmd3("head",mesh_head)
loadanimation(model)
ChangeDir("../")
Return Model

End Function
Function loadskin(model$,skn$)
If Lower(model$)="lower" file$="Lower_"+skn$+".skin"
If model$="upper" file$="upper_"+skn$+".skin"
If model$="head" file$="head_"+skn$+".skin"
DebugLog file$
skinfile=OpenFile(file$)
fg=1
l=0
While Not Eof( skinfile )
t$=ReadLine(skinfile)
;print T$
;For i=1 To Len(t$)
If Len(t$)>1
If Mid$(t$,Len(t$)-3,1)="."

	For i=1 To Len(t$)
	If Mid$(t$,i,1)="/" Or Mid$(t$,i,1)="\"
	bob$=Right(t$,Len(t$)-i)
	skin(l,2)=Right(t$,Len(t$)-i)

	EndIf
	If Mid$(t$,i,1)=","
	skin(l,1)=Left(t$,i-1)
	EndIf
	Next

	l=l+1
	
	Else
	tagname(fg)=Mid(t$,1,Len(t$)-1)
	fg=fg+1
	EndIf
	
;Next
EndIf
Wend
CloseFile skinfile
End Function
Function Loadmd3(model$,mesh)
If Lower(model$)="lower" file$="Lower.md3"
If model$="upper" file$="upper.md3"
If model$="head" file$="head.md3"
Print "file: "+file$
modelfile=OpenFile(file$)
md3.md3=New md3
md3_Handle=Handle(md3)
md3\mesh=mesh
md3\filename$=file$
; readin the header.

md3\header=loadmd3header(modelfile)
hdr.tmd3header=Object.tmd3header(md3\header)
; since I don't care about the bone information i'll delete it since it isn't used for animating ;)
For loop=1 To hdr\numframes
loadMD3Bone(modelfile)
Next
; there, I could make it show the bone in the mesh, but I can't be bothered :P

tint=hdr\numframes * hdr\numtags
md3\tags=CreateBank((tint+1)*4)

For loop=1 To hdr\numframes *hdr\numtags
hand=loadmd3tags(modelfile,(loop-1)/hdr\numtags)
PokeInt md3\tags,(loop)*4,hand

Next



meshoffset=FilePos(modelfile)
; Go through all of the sub-objects in this mesh
For i=1 To hdr\nummeshes
; Seek To the start of this mesh And Read in its header
SeekFile(modelfile,meshoffset)
hand=loadmd3meshinfo(modelfile,meshoffset,mesh)

mshd.tmd3meshinfo=Object.tmd3meshinfo(hand)
meshoffset=meshoffset+mshd\meshsize
md3\meshinfo[i]=hand
Next

CloseFile modelfile

Return md3_handle

End Function


Function LoadMD3Header(file)
	hdr.tMd3header=New tMd3header
	hdr\fileID$=ReadString$(file,4)
	hdr\version=ReadInt(file)
	hdr\strfile$=ReadString$(file,68)
	hdr\numFrames=ReadInt(file)
	hdr\numTags=ReadInt(file)
	hdr\numMeshes=ReadInt(file)
	hdr\numMaxskins=ReadInt(file)
	hdr\headerSize=ReadInt(file)
	hdr\tagstart=ReadInt(file)
	hdr\tagend=ReadInt(file)
	hdr\fsize=ReadInt(file)
	Print hdr\fileiD$ +"  "+hdr\version+"  "+hdr\strfile$
	Print "Number of Skins="+hdr\NumMaxSkins
	Print "Frames:"+hdr\numframes +" TAGS:"+hdr\numtags+" Meshes:"+hdr\numMeshes

	Return Handle(hdr)
End Function


Function LoadMD3Bone(file)
	;bone.tmd3bone=New tmd3bone
	;bone\mins#[1]=
	ReadFloat(file)
	;bone\mins#[2]=
	ReadFloat(file)
	;bone\mins#[3]=
	ReadFloat(file)
	;bone\maxs#[1]=
	ReadFloat(file)
	;bone\maxs#[2]=
	ReadFloat(file)
	;bone\maxs#[3]=
	ReadFloat(file)	
	;bone\position#[1]=
	ReadFloat(file)
	;bone\position#[2]=
	ReadFloat(file)
	;bone\position#[3]=
	ReadFloat(file)
	;bone\scale#=
	ReadFloat(file)
	;bone\creator$=
	ReadString$(file,16)
	; if you want to do stuff with the bones comment this, uncomment the next.
	; this makes the function return the handle of this type
	;Delete bone
	;Return Handle(bone)
End Function

Function loadmd3tags(file,frame)
	tag.tmd3tag = New tmd3tag
	tag\strname$=ReadString$(file,64)
	tag\frame=frame
	tag\vposition[1]=ReadFloat(file) ;x
	tag\vposition[2]=ReadFloat(file) ;y
	tag\vposition[3]=ReadFloat(file) ;z
    Ax#=ReadFloat(file) : Az#=ReadFloat(file) : Ay#=ReadFloat(file)
	Cx#=ReadFloat(file) : Cz#=ReadFloat(file) : Cy#=ReadFloat(file)	    
	Bx#=ReadFloat(file) : Bz#=ReadFloat(file) : By#=ReadFloat(file)
	 temp=CreatePivot()
	 AlignToVector temp,ax,ay,az,1
	 AlignToVector temp,bx,by,bz,2
	 AlignToVector temp,cx,cy,cz,3
	 tag\pitch#=EntityPitch(temp)
	 tag\yaw#=EntityRoll(temp)
	 tag\roll#=EntityPitch(temp)
	 FreeEntity temp
	Return Handle(tag)		
End Function

; reads in a short and converts it to a singed number...
Function ReadSShort(fi)
t=ReadShort(fi)
		If t>32767
		 r=t-65535
		Else
		r=t
		EndIf
		Return R
End Function

Function loadmd3meshinfo(file,pos,mesh,ox#=0,oy#=0,oz#=0)

	mshd.tmd3meshinfo=New tmd3meshinfo
	mshd\meshid$=ReadString$(file,4)
	Print mshd\meshid$
	mshd\strname$=ReadString$(file,68)
	Print 	"name:"+mshd\strname$
	mshd\nummeshframes=ReadInt(file)
	mshd\numskins=ReadInt(file)
	mshd\numvertices=ReadInt(file)
	mshd\numtriangles=ReadInt(file)
	Print "***NOT:"+mshd\numtriangles
tristart=ReadInt(file)
	mshd\headersize=ReadInt(file)
uvstart=ReadInt(file)
vertexstart=ReadInt(file)
	mshd\meshsize=ReadInt(file)
	Print mshd\meshID$+"  "+mshd\strname$
	
	For skins=1 To mshd\numskins

	Next
	; read in the face data.
	SeekFile file, pos+tristart
	Dim face(mshd\numtriangles,3)
	For fce=1 To mshd\numtriangles
	face(fce,1)=ReadInt(file)		;vert 1
	face(fce,2)=ReadInt(file)		;vert 2
	face(fce,3)=ReadInt(file)		;vert 3
	Next
	SeekFile file,pos+uvstart
	Dim uv(mshd\numvertices,2)
	For i=1 To mshd\numvertices
	uv(i,1)=ReadFloat(file)
	uv(i,2)=ReadFloat(file)
	Next
	
	SeekFile file,pos+vertexstart
	surf=CreateSurface(mesh)
	mshd\animbank=CreateBank(((mshd\numvertices * mshd\nummeshframes)+1)*3*2)
	mshd\vertoff=CreateBank(((mshd\numvertices * mshd\nummeshframes)+1)*3*2)


	For f=1 To mshd\nummeshframes
	;; debuglog"FRAME="+f
	For i=1 To mshd\numvertices
		X=ReadSShort(file)
		y=ReadSShort(file)
		Z=ReadSShort(file)

		ReadShort(file)
		PokeShort mshd\animbank,(((f-1)*mshd\numvertices*6)+((i-1)*3*2)),X
		PokeShort mshd\animbank,(2+((f-1)*mshd\numvertices*6)+((i-1)*3*2)),Y
		PokeShort mshd\animbank,(4+((f-1)*mshd\numvertices*6)+((i-1)*3*2)),Z	
			If f=1
			AddVertex surf,(x/64.),(y/64.),(z/64.),uv(i,1),uv(i,2)
		
			
		EndIf
	Next
Next
	For fce=1 To mshd\numtriangles
	

	AddTriangle surf,face(fce,3),face(fce,2),face(fce,1)
	Next
	Dim face(1,1)
	UpdateNormals mesh	
	For o=0 To 15 
	If mshd\strname$=skin(o,1) 
	If FileType(skin(o,2))=1 
		PaintSurface surf,LoadBrush(skin(o,2),4)
	Else
		PaintSurface surf,LoadBrush(skin(0,2),4)
	End If
	EndIf
	Next
	

Return Handle(mshd)
End Function

Function MD3_ANIMATION_FUNCTIONS()
End Function

Function loadanimation(md3.md3model)
animfile=OpenFile("animation.cfg")
n=0
While Not Eof(animfile)
found=0
s$=ReadLine(animfile)
Select Left(s$,1)
Case "0","1","2","3","4","5","6","7","8","9"
anim.tmd3animation=New tmd3animation
For a=1 To Len(s$)
If Mid(s$,a,1)=Chr(9)
	If found=0
	
		anim\startframe=Left(s$,a)
		found=1
	Else If found=1
		found=2
		anim\endframe=Mid(s$,a-2,3)

		
	Else If found=2
	found=3
	anim\loopingframes=(Mid(s$,a-1,3))
	Else If found=3
	found=4
	anim\framespersecond=(Mid(s$,a-2,3))
	
End If
	Else If Mid(s$,a,1)="/"		; "/"
		If Mid(s$,a+1,1) ="/"
			If Mid(s$,a+2,1) =" "
			anim\strname$=Right(s$,Len(s$)-(a+2))
			istab=Instr(anim\strname$,Chr(9))
			If istab
			anim\strname$=Left(anim\strname$,istab-1)
			EndIf				
			md3\animation[n]=Handle(anim)
			If Instr(anim\strname$,"BOTH") anim\part=0
			If Instr(anim\strname$,"TORSO") anim\part=1
			If Instr(anim\strname$,"LEGS") anim\part=2
			
			Print "A NAME:"+anim\strname+" "+n+" Start:"+anim\startframe+" End:"+(anim\endframe)+" PART:"+anim\part

			n=n+1
			EndIf
	EndIf
End If


Next

Default
End Select
Wend
End Function



Function MD3_SetAnim(model.md3model,anm)
anim.tmd3animation=Object.tmd3animation(model\animation[anm])
Print anim\strname+" "+anim\startframe+" "+(anim\startframe+anim\endframe)
If anim\part=0
	md3.md3=Object.md3(model\legs)
	md3\frame=anim\startframe*10			; due to stupid blitz bug with floats.
	md3\startframe=anim\startframe
	md3\endframe=anim\endframe+anim\startframe
	md3.md3=Object.md3(model\body)
	md3\frame=anim\startframe*10			; due to stupid blitz bug with floats.
	md3\startframe=anim\startframe
	md3\endframe=anim\endframe+anim\startframe
	Print "BOTH"
Else If anim\part=1
	md3.md3=Object.md3(model\body)
	md3\frame=anim\startframe*10			; due to stupid blitz bug with floats.
	md3\startframe=anim\startframe
	md3\endframe=anim\endframe+anim\startframe
	md3.md3=Object.md3(model\legs)
;	md3\frame=10			; due to stupid blitz bug with floats.
;	md3\startframe=1
;	md3\endframe=1
	Print "BODY"
Else If anim\part=2
	md3.md3=Object.md3(model\legs)
	md3\frame=anim\startframe*10			; due to stupid blitz bug with floats.
	md3\startframe=anim\startframe
	md3\endframe=anim\endframe+anim\startframe
	md3.md3=Object.md3(model\body)
;	md3\frame=10			; due to stupid blitz bug with floats.
;	md3\startframe=1
;	md3\endframe=1
	Print "LEGS"
EndIf
End Function


Function MD3_UPDATEANIM(model.md3model)
	md3.md3=Object.md3(model\legs)
	mesh_lower=md3\mesh
	If md3\frame/10=md3\endframe md3\frame=md3\startframe*10
	If md3\startframe<>md3\endframe
	interpolation(md3)
	md3\frame=md3\frame+1
	EndIf

	
	md3.md3=Object.md3(model\body)
	mesh_upper=md3\mesh
	If md3\frame/10=md3\endframe md3\frame=md3\startframe*10
	If md3\startframe<>md3\endframe
	 interpolation(md3)
	md3\frame=md3\frame+1
	EndIf
	
	

	md3.md3=Object.md3(model\head)
	mesh_head=md3\mesh
	
	md3.md3=Object.md3(model\legs)
		If Right(Int(md3\frame),1)="0"
	allignbody(model,mesh_upper)
	Else 
			md3.md3=Object.md3(model\legs)
		For lp=4 To BankSize(md3\tags)-1 Step 4
	
			hand=PeekInt(md3\tags,lp)
			tag.tmd3tag=Object.tmd3tag(hand)
			If tag\strname=Lower("TAG_TORSO") And tag\frame=Int((md3\frame/10)+1)
				px2#=tag\vposition[1] : py2#=tag\vposition[2] : pz2#=tag\vposition[3]
			EndIf
		Next
		For lp=4 To BankSize(md3\tags)-1 Step 4
			hand=PeekInt(md3\tags,lp)
			tag.tmd3tag=Object.tmd3tag(hand)
			If tag\strname=Lower("TAG_TORSO") And tag\frame=Int(md3\frame/10)
				px#=tag\vposition[1] : py#=tag\vposition[2] : pz#=tag\vposition[3]
				
			EndIf
		Next	
		sx#=.1*(px2#-px#) : sy#=.1*(py2#-py#) : sz#=.1*(pz2#-pz#)
		PositionEntity mesh_upper,EntityX(mesh_upper)+sx#,EntityY(mesh_upper)+sY#,EntityZ(mesh_upper)+sz#
	EndIf
	md3.md3=Object.md3(model\body)
		If Right(Int(md3\frame),1)="0"
	allignhead(model,mesh_head)
	Else 
		md3.md3=Object.md3(model\body)
		For lp=4 To BankSize(md3\tags)-1 Step 4
	
			hand=PeekInt(md3\tags,lp)
			tag.tmd3tag=Object.tmd3tag(hand)
			If tag\strname=Lower("TAG_HEAD") And tag\frame=Int((md3\frame/10)+1)
				px2#=tag\vposition[1] : py2#=tag\vposition[2] : pz2#=tag\vposition[3]
			EndIf
		Next
		For lp=4 To BankSize(md3\tags)-1 Step 4
			hand=PeekInt(md3\tags,lp)
			tag.tmd3tag=Object.tmd3tag(hand)
			If tag\strname=Lower("TAG_HEAD") And tag\frame=Int(md3\frame/10)
				px#=tag\vposition[1] : py#=tag\vposition[2] : pz#=tag\vposition[3]
				
			EndIf
		Next	
		sx#=.1*(px2#-px#) : sy#=.1*(py2#-py#) : sz#=.1*(pz2#-pz#)
		PositionEntity mesh_head,EntityX(mesh_head)+sx#,EntityY(mesh_head)+sY#,EntityZ(mesh_head)+sz#
		;RotateEntity mesh_head,tag\pitch#,tag\yaw#,tag\roll
	EndIf


End Function
Function MD3_QUPDATEANIM(model.md3model)
	md3.md3=Object.md3(model\legs)
	mesh_lower=md3\mesh
	If md3\startframe<>md3\endframe
	Frame_update(md3)
	md3\frame=md3\frame+1
	EndIf
	If md3\frame/10=md3\endframe md3\frame=md3\startframe*10
	
	md3.md3=Object.md3(model\body)
	mesh_upper=md3\mesh
	If md3\startframe<>md3\endframe
	 Frame_update(md3)
	md3\frame=md3\frame+1
	EndIf
	If md3\frame/10=md3\endframe md3\frame=md3\startframe*10
	

	md3.md3=Object.md3(model\head)
	mesh_head=md3\mesh
	
	md3.md3=Object.md3(model\legs)
		If Right(Int(md3\frame),1)="0"
	allignbody(model,mesh_upper)
	Else 
			md3.md3=Object.md3(model\legs)
		For lp=4 To BankSize(md3\tags)-1 Step 4
	
			hand=PeekInt(md3\tags,lp)
			tag.tmd3tag=Object.tmd3tag(hand)
			If tag\strname=Lower("TAG_TORSO") And tag\frame=Int((md3\frame/10)+1)
				px2#=tag\vposition[1] : py2#=tag\vposition[2] : pz2#=tag\vposition[3]
			EndIf
		Next
		For lp=4 To BankSize(md3\tags)-1 Step 4
			hand=PeekInt(md3\tags,lp)
			tag.tmd3tag=Object.tmd3tag(hand)
			If tag\strname=Lower("TAG_TORSO") And tag\frame=Int(md3\frame/10)
				px#=tag\vposition[1] : py#=tag\vposition[2] : pz#=tag\vposition[3]
				
			EndIf
		Next	
		sx#=.1*(px2#-px#) : sy#=.1*(py2#-py#) : sz#=.1*(pz2#-pz#)
		PositionEntity mesh_upper,EntityX(mesh_upper)+sx#,EntityY(mesh_upper)+sY#,EntityZ(mesh_upper)+sz#
	EndIf
	md3.md3=Object.md3(model\body)
		If Right(Int(md3\frame),1)="0"
	allignhead(model,mesh_head)
	Else 
		md3.md3=Object.md3(model\body)
		For lp=4 To BankSize(md3\tags)-1 Step 4
	
			hand=PeekInt(md3\tags,lp)
			tag.tmd3tag=Object.tmd3tag(hand)
			If tag\strname=Lower("TAG_HEAD") And tag\frame=Int((md3\frame/10)+1)
				px2#=tag\vposition[1] : py2#=tag\vposition[2] : pz2#=tag\vposition[3]
			EndIf
		Next
		For lp=4 To BankSize(md3\tags)-1 Step 4
			hand=PeekInt(md3\tags,lp)
			tag.tmd3tag=Object.tmd3tag(hand)
			If tag\strname=Lower("TAG_HEAD") And tag\frame=Int(md3\frame/10)
				px#=tag\vposition[1] : py#=tag\vposition[2] : pz#=tag\vposition[3]
				
			EndIf
		Next	
		sx#=.1*(px2#-px#) : sy#=.1*(py2#-py#) : sz#=.1*(pz2#-pz#)
		PositionEntity mesh_head,EntityX(mesh_head)+sx#,EntityY(mesh_head)+sY#,EntityZ(mesh_head)+sz#
		;RotateEntity mesh_head,tag\pitch#,tag\yaw#,tag\roll
	EndIf


End Function

Function Frame_update(md3.md3)
If Right(Int(md3\frame),1)="0"
	mesh_upper=md3\mesh
	surfs=CountSurfaces(mesh_upper)
	For lp=1 To surfs
	mshd.tmd3meshinfo=Object.tmd3meshinfo(md3\meshinfo[lp])
	surf=GetSurface(mesh_upper,lp)
	verts=CountVertices(surf)
	fn=(Int(Floor((md3\frame/10))))
	For i=1 To verts
	frameno=(fn*verts*6)+((i-1)*6)
		X#=PeeksShort(mshd\animbank,(frameno))
		Y#=PeeksShort(mshd\animbank,(2+frameno))
		Z#=PeeksShort(mshd\animbank,(4+frameno))
		VertexCoords surf,i-1,X/64,Y/64,Z/64
	Next
	Next
End If
If Right(Int(md3\frame),1)="5"
mesh_upper=md3\mesh
	surfs=CountSurfaces(mesh_upper)
	For lp=1 To surfs
	mshd.tmd3meshinfo=Object.tmd3meshinfo(md3\meshinfo[lp])
	surf=GetSurface(mesh_upper,lp)
	verts=CountVertices(surf)
	fn=(Int(Floor((md3\frame/10))))
	For i=1 To verts
		frameno=(fn*verts*6)+((i-1)*6)
		frameno2=((1+fn)*verts*6)+((i-1)*6)
		X#=PeeksShort(mshd\animbank,(frameno))
		Y#=PeeksShort(mshd\animbank,(2+frameno))
		Z#=PeeksShort(mshd\animbank,(4+frameno))
		sx#=VertexX(surf,i-1)
		sy#=VertexY(surf,i-1)
		sZ#=VertexZ(surf,i-1)
		X2#=PeeksShort(mshd\animbank,(frameno2))
		Y2#=PeeksShort(mshd\animbank,(2+frameno2))
		Z2#=PeeksShort(mshd\animbank,(4+frameno2))
		px#=.1*(x2#-x#)
		py#=.1*(y2#-y#)
		pz#=.1*(z2#-z#)
		VertexCoords surf,i-1,sx+(px/64),sy+(py/64),sz+(pz/64)
	Next

	Next

EndIf
End Function

Function interpolation(md3.md3)
	If Right(Int(md3\frame),1)="0"
	mesh_upper=md3\mesh
	surfs=CountSurfaces(mesh_upper)
	For lp=1 To surfs
	mshd.tmd3meshinfo=Object.tmd3meshinfo(md3\meshinfo[lp])
	surf=GetSurface(mesh_upper,lp)
	verts=CountVertices(surf)
	fn=(Int(Floor((md3\frame/10))))
	For i=1 To verts
	frameno=(fn*verts*6)+((i-1)*6)
		X#=PeeksShort(mshd\animbank,(frameno))
		Y#=PeeksShort(mshd\animbank,(2+frameno))
		Z#=PeeksShort(mshd\animbank,(4+frameno))
		VertexCoords surf,i-1,X/64,Y/64,Z/64
	Next

	Next
	Else
	mesh_upper=md3\mesh
	surfs=CountSurfaces(mesh_upper)
	For lp=1 To surfs
	mshd.tmd3meshinfo=Object.tmd3meshinfo(md3\meshinfo[lp])
	surf=GetSurface(mesh_upper,lp)
	verts=CountVertices(surf)
	fn=(Int(Floor((md3\frame/10))))
	For i=1 To verts
		frameno=(fn*verts*6)+((i-1)*6)
		frameno2=((1+fn)*verts*6)+((i-1)*6)
		X#=PeeksShort(mshd\animbank,(frameno))
		Y#=PeeksShort(mshd\animbank,(2+frameno))
		Z#=PeeksShort(mshd\animbank,(4+frameno))
		sx#=VertexX(surf,i-1)
		sy#=VertexY(surf,i-1)
		sZ#=VertexZ(surf,i-1)
		X2#=PeeksShort(mshd\animbank,(frameno2))
		Y2#=PeeksShort(mshd\animbank,(2+frameno2))
		Z2#=PeeksShort(mshd\animbank,(4+frameno2))
		px#=.1*(x2#-x#)
		py#=.1*(y2#-y#)
		pz#=.1*(z2#-z#)
		VertexCoords surf,i-1,sx+(px/64),sy+(py/64),sz+(pz/64)
	Next

	Next

	
	EndIf
End Function

Function allignbody(model.md3model,mesh_upper)
	md3.md3=Object.md3(model\legs)
	For lp=4 To BankSize(md3\tags)-1 Step 4
		hand=PeekInt(md3\tags,lp)
		tag.tmd3tag=Object.tmd3tag(hand)
		If tag\strname=Lower("TAG_TORSO") And tag\frame=md3\frame/10

			PositionEntity mesh_upper,tag\vposition[1],tag\vposition[2],tag\vposition[3]
			RotateEntity mesh_upper,tag\pitch#,tag\yaw#,tag\roll#
			Exit
		EndIf
	Next
End Function
Function allignhead(model.md3model,mesh_head)

	md3.md3=Object.md3(model\body)
	For lp=4 To BankSize(md3\tags)-1 Step 4
		hand=PeekInt(md3\tags,lp)
		tag.tmd3tag=Object.tmd3tag(hand)
		If tag\strname=Lower("TAG_HEAD") And tag\frame=md3\frame/10
			PositionEntity mesh_head,tag\vposition[1],tag\vposition[2],tag\vposition[3]
			RotateEntity mesh_head,tag\pitch#,tag\yaw#,tag\roll
			Exit
		EndIf
	Next
End Function
Function NON_MD3_FUNCTIONS()
End Function



Function PeekSShort(bank,offset)
If offset<0 Return 0
;DebugLog bank+" "+offset
t=PeekShort(bank,offset)
		If t>32767
		 r=t-65535
		Else
		r=t
		EndIf
		Return R
End Function

Function ReadString$(fi,leng)
ch$=""
For l=1 To leng
dta=ReadByte(fi)
If dta=0 And done=0

ch2$=ch$;+" "
done=1
Else If done=1

Else
ch$=ch$+Chr(dta)
EndIf
Next
Return ch2$
End Function


; The Quake3 .Md3 file format is owned by ID Software.  This tutorial is being used 
; as a teaching tool To help understand model loading And animation.  This should
; Not be sold Or used under any way For commercial use with out written consent
; from ID Software.
;
; Quake, Quake2 And Quake3 are trademarks of ID Software.